# pbP[W̓ǂݍ --------------------------------------------------------------
library(psych)
library(lavaan)
library(semTools)

# fBNg̕ύX ----------------------------------
setwd("")

# f[^̓ǂݍ ------------------------------------------------------------
d0 <- read.csv("ch07.csv")

# f[^̊mF -----------------------------------------------------------
head(d0)
tail(d0)
nrow(d0)

#f[^̌^̊mF@
str(d0)

#1. lmFl̂f[^폜
d0[!complete.cases(d0),]
d <- na.omit(d0)

# bv -------------------------------------------------------------------

# t]
#2. eڂɑ΂񓚂̏󋵂mFixzAρAW΍j
# t]
d$c_d3r <- 6-d$c_d3
d$k_d3r <- 6-d$k_d3

# ρCW΍
describeBy(d,group = d$grade)
#ړ_̓xz
table(d$c_d1)
#
table(d$k_d3r)
# wN̓xz
table(d$grade)


# U\ -----------------------------------------------------------------
#Ă͂߂郂f̒`
model_sem <- '
## 
c_douki =~ c_d1 + c_d2 + c_d3r@# Ԏ@Â
c_seika =~ c_rm + c_rj + c_re@# ԎwK
k_douki =~ k_d1 + k_d2 + k_d3r@# @Â
k_seika =~ k_rm + k_rj + k_re  # wK
## \
c_seika ~ c_douki
k_douki ~ c_seika + c_douki 
k_seika ~ c_seika + k_douki
'

#s
fit <- sem(model = model_sem, data = d, std.lv = TRUE)
summary(fit, standardized=TRUE,fit.measures = TRUE)
fitMeasures(fit)


#library(semTools)



# wNʂɎsiWcj
## zusσf
fit_ci <- sem(model = model_sem, data = d, group = "grade", std.lv = T)
summary(fit_ci, standardized=T,fit.measures = T)
fitMeasures(fit_ci)

## 㑪sρiweak factorial invariance/metric invariancejf
fit_wfi <- sem(model = model_sem, data = d, group = "grade", group.equal = c("loadings"), std.lv = T)
summary(fit_wfi, standardized=T,fit.measures = T)
fitMeasures(fit_wfi)

## sρistrong factorial invariance/scalar invariancejf
fit_sfi <- sem(model = model_sem, data = d, group = "grade", group.equal = c("loadings","intercepts"), std.lv = T)
summary(fit_sfi, standardized=T,fit.measures = T)
fitMeasures(fit_sfi)

## sρimeasurement invariancejf
fit_mi <- sem(model = model_sem, data = d, group = "grade", group.equal = c("loadings","intercepts","residuals"), std.lv = T)
summary(fit_mi, standardized=T,fit.measures = T)
fitMeasures(fit_mi)

## Sꐔf
fit_all <- sem(model = model_sem, data = d, group = "grade", group.equal = c("loadings","intercepts","residuals","means"), std.lv = T)
summary(fit_all, standardized=T,fit.measures = T)
fitMeasures(fit_all)

#Ql
res <- compareFit(fit_ci,fit_wfi,fit_sfi,fit_mi,fit_all)
res


############################\Ɋւ###################################

# ԌʁAԓ@Ԃ𓙒l
# sem̃f
wfi_crcd <- '
## 
c_d =~ c_d1 + c_d2 + c_d3@# Ԏ@Â
c_r =~ c_rm + c_rj + c_re@# ԎwK
k_d =~ k_d1 + k_d2 + k_d3@# @Â
k_r =~ k_rm + k_rj + k_re  # wK
## \
c_r ~ c(v1,v1)*c_d
k_d ~ c_r + c_d 
k_r ~ c_r + k_d
'

fit_wfi_crcd <- sem(model = wfi_crcd, data = d, group = "grade", group.equal = c("loadings"), std.lv = T)
summary(fit_wfi_crcd, standardized=T,fit.measures = T)
fitMeasures(fit_wfi_crcd)

# ԌʁA@Ԃ𓙒l
# sem̃f
wfi_kdcr <- '
## 
c_d =~ c_d1 + c_d2 + c_d3@# Ԏ@Â
c_r =~ c_rm + c_rj + c_re@# ԎwK
k_d =~ k_d1 + k_d2 + k_d3@# @Â
k_r =~ k_rm + k_rj + k_re  # wK
## \
c_r ~ c_d
k_d ~ c(v2,v2)*c_r + c_d 
k_r ~ c_r + k_d
'

fit_wfi_kdcr <- sem(model = wfi_kdcr, data = d, group = "grade", group.equal = c("loadings"), std.lv = T)
summary(fit_wfi_kdcr, standardized=T,fit.measures = T)
fitMeasures(fit_wfi_kdcr)


# ԓ@A@Ԃ𓙒l
# sem̃f
wfi_kdcd <- '
## 
c_d =~ c_d1 + c_d2 + c_d3@# Ԏ@Â
c_r =~ c_rm + c_rj + c_re@# ԎwK
k_d =~ k_d1 + k_d2 + k_d3@# @Â
k_r =~ k_rm + k_rj + k_re  # wK
## \
c_r ~ c_d
k_d ~ c_r + c(v3,v3)*c_d 
k_r ~ c_r + k_d
'

fit_wfi_kdcd <- sem(model = wfi_kdcd, data = d, group = "grade", group.equal = c("loadings"), std.lv = T)
summary(fit_wfi_kdcd, standardized=T,fit.measures = T)
fitMeasures(fit_wfi_kdcd)



# ԌʁAʊԂ𓙒l
# sem̃f
wfi_krcr <- '
## 
c_d =~ c_d1 + c_d2 + c_d3@# Ԏ@Â
c_r =~ c_rm + c_rj + c_re@# ԎwK
k_d =~ k_d1 + k_d2 + k_d3@# @Â
k_r =~ k_rm + k_rj + k_re  # wK
## \
c_r ~ c_d
k_d ~ c_r + c_d 
k_r ~ c(v4,v4)*c_r + k_d
'

fit_wfi_krcr <- sem(model = wfi_krcr, data = d, group = "grade", group.equal = c("loadings"), std.lv = T)
summary(fit_wfi_krcr, standardized=T,fit.measures = T)
fitMeasures(fit_wfi_krcr)

# @AʊԂ𓙒l
# sem̃f
wfi_krkd <- '
## 
c_d =~ c_d1 + c_d2 + c_d3@# Ԏ@Â
c_r =~ c_rm + c_rj + c_re@# ԎwK
k_d =~ k_d1 + k_d2 + k_d3@# @Â
k_r =~ k_rm + k_rj + k_re  # wK
## \
c_r ~ c_d
k_d ~ c_r + c_d 
k_r ~ c_r + c(v5,v5)*k_d
'

fit_wfi_krkd <- sem(model = wfi_krkd, data = d, group = "grade", group.equal = c("loadings"), std.lv = T)
summary(fit_wfi_krkd, standardized=T,fit.measures = T)
fitMeasures(fit_wfi_krkd)


#######################################################

# ԌʁAԓ@Ԃ𓙒l
# sem̃f
wfi_crcd_kdcr <- '
## 
c_d =~ c_d1 + c_d2 + c_d3@# Ԏ@Â
c_r =~ c_rm + c_rj + c_re@# ԎwK
k_d =~ k_d1 + k_d2 + k_d3@# @Â
k_r =~ k_rm + k_rj + k_re  # wK
## \
c_r ~ c(v1,v1)*c_d
k_d ~ c(v2,v2)*c_r + c_d 
k_r ~ c_r + k_d
'

fit_wfi_crcd_kdcr <- sem(model = wfi_crcd_kdcr, data = d, group = "grade", group.equal = c("loadings"), std.lv = T)
summary(fit_wfi_crcd_kdcr, standardized=T,fit.measures = T)
fitMeasures(fit_wfi_crcd_kdcr)

# ԌʁAԓ@Ԃ𓙒l
# sem̃f
wfi_crcd_kdcd <- '
## 
c_d =~ c_d1 + c_d2 + c_d3@# Ԏ@Â
c_r =~ c_rm + c_rj + c_re@# ԎwK
k_d =~ k_d1 + k_d2 + k_d3@# @Â
k_r =~ k_rm + k_rj + k_re  # wK
## \
c_r ~ c(v1,v1)*c_d
k_d ~ c_r + c(v3,v3)*c_d 
k_r ~ c_r + k_d
'

fit_wfi_crcd_kdcd <- sem(model = wfi_crcd_kdcd, data = d, group = "grade", group.equal = c("loadings"), std.lv = T)
summary(fit_wfi_crcd, standardized=T,fit.measures = T)
fitMeasures(fit_wfi_crcd_kdcd)


